* Inverse Gauss Chapter
drop _all

clear
set seed 2348
set obs 10
generate byte mu = 5
generate byte y = _n
generate phi = 2
generate yig = exp((-phi*(y-mu)^2)/(2*mu^2*y)) * sqrt(phi/(2*_pi*y^3))
list y yig

twoway function y = exp((-2.0*(x-5.0)^2)/(2*5.0^2*x)) * sqrt(2.0/(2*_pi*x^3)), ///
	range(1 10) title("Inverse Gaussian: mu=5.0; phi=2.0")

twoway function y = exp((-2.0*(x-10.0)^2)/(2*10.0^2*x)) * sqrt(2.0/(2*_pi*x^3)), range(1 10) title("Inverse Gaussian: mu=10.0; phi=2.0")
twoway function y = exp((-0.4*(x-10.0)^2)/(2*10.0^2*x)) * sqrt(0.4/(2*_pi*x^3)), range(1 10) title("Inverse Gaussian: mu=10.0; phi=0.4")
twoway function y = exp((-0.1*(x-3.0)^2)/(2*3.0^2*x)) * sqrt(0.1/(2*_pi*x^3)), range(1 10) title("Inverse Gaussian: mu=3.0; phi=0.1")
twoway function y = exp((-8.0*(x-2.0)^2)/(2*2.0^2*x)) * sqrt(8.0/(2*_pi*x^3)), range(1 10) title("Inverse Gaussian: mu=2.0; phi=8.0")
twoway function y = exp((-8.0*(x-10.0)^2)/(2*10.0^2*x)) * sqrt(8.0/(2*_pi*x^3)), range(1 10) title("Inverse Gaussian: mu=10.0; phi=8.0")

clear
set seed 12345
set obs 25000
generate x1 = abs(rnormal())
generate x2 = abs(rnormal())
generate eta = 1 + .5*x1 + .25*x2
generate mu = 1/sqrt(eta)
generate xig = rigaussian(mu, 1/0.25)
glm xig x1 x2, family(igaussian) nolog

use medpar1, clear
glm los admitype codes, family(igaussian) link(log) nolog

glm los admitype i.codes, family(igaussian) link(log) nolog
glm los admitype i.codes, family(igaussian) link(identity) nolog
glm los admitype i.codes, family(igaussian) nolog
aic
