* Negative binomial Chapter
drop _all

clear

use medpar
nbreg los hmo white type2 type3, irr nolog
glm los hmo white type2 type3, family(nbinomial ml) eform nolog

negbin los hmo white type2 type3, eform

use doll
glm deaths smokes a2-a5, family(nbinomial 0.09414) exposure(pyears) eform nolog

clear
set obs 10000
set seed 4321
generate x1 = rnormal()
generate x2 = rnormal()
generate expxb = exp(0.75*x1 - 1.25*x2 + 2)
generate nby = rpoisson(rgamma(1/.5, .5) * expxb)
glm nby x1 x2, family(nbinomial ml) nolog

capture program drop NegbinSim
program NegbinSim, rclass
    quietly {
	drop _all
	set obs 10000
        generate x1 = rnormal()
        generate x2 = rnormal()
        generate nby = rpoisson(rgamma(1/.5,.5)*exp(0.75*x1-1.25*x2+2))
        glm nby x1 x2, family(nbinomial ml)
    }
    return scalar pearson  = e(dispers_p)
    return scalar deviance = e(dispers_s) 
end

simulate pearson=r(pearson) deviance=r(deviance), reps(100) nodots: NegbinSim
summarize

drop _all
input LOS npatients
1  50
2  40
3  30
4  20
5  15
6  12
7  10
8   7
9   6
10  6
11  5
12  5
13  4
14  3
15  2
16  0
end
twoway (scatter npatients LOS), ylabel(0 2 4 6 8 10 20 30 40 50) xlabel(1(1)16)

use medpar, clear
glm los white type2 type3, family(nbinomial 1) link(nbinomial) eform nolog

glm los white type2 type3, family(nbinomial 1) link(nbinomial) scale(x2) eform nolog noheader
glm los white type2 type3, family(nbinomial 1) link(nbinomial) vce(cluster provnum) eform nolog noheader

glm los white type2 type3, family(nbinomial ml) link(nbinomial) eform nolog
