* Poisson Chapter
drop _all

clear

use medpar
glm los hmo white type2 type3, family(poisson) eform nolog

glm los hmo white type2 type3, family(poisson) irls scale(x2) eform noheader nolog

glm los hmo white type2 type3, family(poisson) cluster(provnum) eform noheader nolog


use doll
glm deaths smokes a2-a5, family(poisson) exposure(pyears) eform nolog

glm deaths smokes a2-a5, family(poisson) irls scale(x2) exposure(pyears) eform noheader nolog


generate sa12 = smokes*(a1+a2)
generate sa34 = smokes*(a3+a4)
generate sa5  = smokes*(a5)
glm deaths sa12 sa34 sa5 a2-a5, family(poisson) irls scale(x2) exposure(pyears) eform noheader nolog


use medpar, clear
glm los hmo white type2 type3, family(poisson) eform noheader nolog
predict double mu, mu
generate z = ((los-mu)^2-los)/(mu*sqrt(2))
regress z

quietly summarize los if e(sample), meanonly
quietly scalar nybar = r(sum)
quietly generate double musq = mu*mu
quietly summarize musq if e(sample), meanonly
quietly scalar mu2 = r(sum)
quietly scalar chival = (mu2-nybar)^2/(2*mu2)
display as txt "LM value = " as res chival _n as txt "P-value  = " as res %6.4f chi2tail(1, chival)


sysuse cancer, clear
glm died age i.drug, exposure(studytime) family(poisson) nolog
stset studytime, failure(died)
streg age i.drug, nohr distribution(exponential) nolog

glm died age i.drug, exposure(studytime) family(poisson) noheader nolog

test age=0, notest
test 2.drug=-1.5, accumulate

estimates store Unconstrained

generate double offvar = 0*age - 1.5*2.drug + log(studytime)

glm died 3.drug, offset(offvar) family(poisson) nolog 
lrtest Unconstrained

constraint 1 age=0
constraint 2 2.drug=-1.5
glm died age i.drug, exposure(studytime) family(poisson) constraints(1 2) nolog
lrtest Unconstrained

use medpar, clear
glm los hmo white type2 type3, family(poisson) noheader nolog
